#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>

#include "v3.h"
#include "ppc.h"

class FrameBuffer : public Fl_Gl_Window {
public:
  unsigned int *pix;
  float *zb;
  int w, h;
  FrameBuffer(int u0, int v0, int _w, int _h);
  void Set(unsigned int color);
  void SetZB(float z0);
  unsigned int Get(int u, int v);
  void Set(int u, int v, unsigned int color);
  void Set(V3 P, unsigned int color);
  bool CloserThenSet(V3 P);
  void SetGuarded(V3 P, unsigned int color);
  void draw();
  void SetAsChecker(int cs, unsigned int cols[2]);
  void DrawSegment(V3 P0, V3 P1, V3 c0, V3 c1);
  void DrawSegment3D(V3 P0, V3 P1, V3 c0, V3 c1, PPC *ppc);
  void Brighten(float scf);
  void FindEdges();
  void FindEdges(FrameBuffer *edgeMap);
  V3 Getv(int u, int v);
  int handle(int event);
  void KeyboardHandle();
};
